/*
 * MATLAB Compiler: 3.0
 * Date: Wed Aug 25 13:39:08 2004
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-W" "main" "-L" "C"
 * "-t" "-T" "link:lib" "-h" "test_track" "libmmfile.mlib" "-v" 
 */
#include "block2fft.h"
#include "libmatlbm.h"
static mxArray * _mxarray0_;
static mxArray * _mxarray1_;

void InitializeModule_block2fft(void) {
    _mxarray0_ = mclInitializeDouble(2.0);
    _mxarray1_ = mclInitializeDouble(1.0);
}

void TerminateModule_block2fft(void) {
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mblock2fft(int nargout_,
                            mxArray * wav,
                            mxArray * samplefreq,
                            mxArray * minfreq,
                            mxArray * maxfreq);

_mexLocalFunctionTable _local_function_table_block2fft
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfBlock2fft" contains the normal interface for the
 * "block2fft" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/block2fft.m" (lines 1-19). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
mxArray * mlfBlock2fft(mxArray * wav,
                       mxArray * samplefreq,
                       mxArray * minfreq,
                       mxArray * maxfreq) {
    int nargout = 1;
    mxArray * p = NULL;
    mlfEnterNewContext(0, 4, wav, samplefreq, minfreq, maxfreq);
    p = Mblock2fft(nargout, wav, samplefreq, minfreq, maxfreq);
    mlfRestorePreviousContext(0, 4, wav, samplefreq, minfreq, maxfreq);
    return mlfReturnValue(p);
}

/*
 * The function "mlxBlock2fft" contains the feval interface for the "block2fft"
 * M-function from file "/afs/cs.cmu.edu/user/dhoiem/code_for_c/block2fft.m"
 * (lines 1-19). The feval function calls the implementation version of
 * block2fft through this function. This function processes any input arguments
 * and passes them to the implementation version of the function, appearing
 * above.
 */
void mlxBlock2fft(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: block2fft Line: 8 Column:"
            " 1 The function \"block2fft\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: block2fft Line: 8 Column:"
            " 1 The function \"block2fft\" was called with m"
            "ore than the declared number of inputs (4)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0] = Mblock2fft(nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mblock2fft" is the implementation version of the "block2fft"
 * M-function from file "/afs/cs.cmu.edu/user/dhoiem/code_for_c/block2fft.m"
 * (lines 1-19). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * % BLOCK2FFT  Calculates the power in each frequency of a block of sound sample.
 * %
 * %  Power = BLOCK2FFT(WAV, SAMPLEFREQ, MINFREQ, MAXFREQ)
 * %
 * % Returns only the frequencies specified by minfreq and maxfreq,
 * % where samplefreq is the sample frequency of the wav.
 * 
 * function p = block2fft(wav, samplefreq, minfreq, maxfreq)
 */
static mxArray * Mblock2fft(int nargout_,
                            mxArray * wav,
                            mxArray * samplefreq,
                            mxArray * minfreq,
                            mxArray * maxfreq) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_block2fft);
    mxArray * p = NULL;
    mxArray * l2 = NULL;
    mxArray * l1 = NULL;
    mxArray * seconds = NULL;
    mxArray * f = NULL;
    mxArray * num_samples = NULL;
    mclCopyArray(&wav);
    mclCopyArray(&samplefreq);
    mclCopyArray(&minfreq);
    mclCopyArray(&maxfreq);
    /*
     * 
     * num_samples = length(wav);
     */
    mlfAssign(&num_samples, mlfScalar(mclLengthInt(mclVa(wav, "wav"))));
    /*
     * 
     * f = fft(wav)/(num_samples/2);
     */
    mlfAssign(
      &f,
      mclMrdivide(
        mlfFft(mclVa(wav, "wav"), NULL, NULL),
        mclMrdivide(mclVv(num_samples, "num_samples"), _mxarray0_)));
    /*
     * seconds = num_samples / samplefreq;
     */
    mlfAssign(
      &seconds,
      mclMrdivide(
        mclVv(num_samples, "num_samples"), mclVa(samplefreq, "samplefreq")));
    /*
     * l1 = floor(seconds * minfreq + 1);
     */
    mlfAssign(
      &l1,
      mlfFloor(
        mclPlus(
          mclMtimes(mclVv(seconds, "seconds"), mclVa(minfreq, "minfreq")),
          _mxarray1_)));
    /*
     * l2 = floor(seconds * maxfreq + 1);
     */
    mlfAssign(
      &l2,
      mlfFloor(
        mclPlus(
          mclMtimes(mclVv(seconds, "seconds"), mclVa(maxfreq, "maxfreq")),
          _mxarray1_)));
    /*
     * 
     * p = abs(f(l1:l2)).^2;
     */
    mlfAssign(
      &p,
      mlfPower(
        mlfAbs(
          mclArrayRef1(
            mclVv(f, "f"), mlfColon(mclVv(l1, "l1"), mclVv(l2, "l2"), NULL))),
        _mxarray0_));
    mclValidateOutput(p, 1, nargout_, "p", "block2fft");
    mxDestroyArray(num_samples);
    mxDestroyArray(f);
    mxDestroyArray(seconds);
    mxDestroyArray(l1);
    mxDestroyArray(l2);
    mxDestroyArray(maxfreq);
    mxDestroyArray(minfreq);
    mxDestroyArray(samplefreq);
    mxDestroyArray(wav);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return p;
    /*
     * 
     */
}
