#include <stdlib.h>
#include <stdio.h>
/*#include "libmatlbm.h"*/
#include "mat.h"
#include "matrix.h"
/*#include "load_classifiers.h"*/

int
main(int argc, const char ** argv) {
  if (argc < 2) {
    printf("syntax: test_classifier_read <filename>\n");
    printf("Reads sound detection classifier from Matlab saved file.\n");
  }
  
  printf("reading %s\n", argv[1]);

  MATFile* classifier_file;
  mxArray* classifier_mx;
  mxArray* dataLength_mx;

  classifier_file = matOpen(argv[1], "r");
  if (classifier_file == 0) {
    printf("null file\n");
  }
		       
  printf("opened file\n");
  int numvars;
  char** varnames = matGetDir(classifier_file, &numvars);
  printf("num names: %d\n", numvars);
  int i = 0;
  for (i = 0; i < numvars; i++) { 
    printf("%s\n", varnames[i]);
  }
  
  
  classifier_mx = matGetVariable(classifier_file, varnames[0]);
  if (classifier_mx == 0) {
    printf("null classifier\n");
  }
    
  printf("got classifier mxArray\n");
  /*InitializeModule_load_classifiers();*/
  int numFields = mxGetNumberOfFields(classifier_mx);
  printf("Number of fields: %d\n", numFields);
  dataLength_mx = mxGetField(classifier_mx, 0, "data_length");
  if (dataLength_mx == 0) {
    printf("DataLength null\n");
  }

  double* tmp = (double*)mxGetData(dataLength_mx);
  int dataLength = (int)tmp[0];
  printf("Data length: %d\n", dataLength);
	    
  mxDestroyArray(classifier_mx);
  matClose(classifier_file);
}
