% features(1:39, num_samples)
% assume 16 bands
%   01 - 16: band_mean_t - mean+-std {1, 2, 3}
%   17 - 32: band_std_t - mean+-std {1, 2, 3}
%   33 - 34: mpb - {1-4} , {1-16}           
%   35:      mpb_std_t - mean+-std {1, 2, 3}
%   36:      band_width_50 - mean+-std {1, 2, 3}
%   37:      nsb_mean_t - mean+-std {1, 2, 3}
%   38:      nsb_std_t - mean+-std {1, 2, 3}
%   39:      power_std - mean+-std {1, 2, 3}
%   40-43:   mean+-std {1, 2, 3}
% partitions.{num_partitions, boundaries}
function partitions = compute_partition_boundaries(features)
    mean_f = mean(features, 2);
    std_f = std(features, 0, 2);
    for f = 1:32
        partitions(f).num_partitions = 3;
        partitions(f).boundaries = [mean_f(f)-std_f(f) ; mean_f(f)+std_f(f)];
    end
    partitions(33).num_partitions = 0;
    partitions(34).num_partitions = 0;
    for f = 35:43
        partitions(f).num_partitions = 3;
        partitions(f).boundaries = [mean_f(f)-std_f(f) ; mean_f(f)+std_f(f)];
    end