function clips = read_wav_files(data_dir, fn_list)
    fid = fopen(fn_list, 'rt');
    num_clips = 0;
    while feof(fid) == 0
        num_clips = num_clips + 1;
        clip_fn = fgetl(fid);
        %disp([data_dir, '/', clip_fn])
        try
            [clips(num_clips).data, fs] = wavread([data_dir, '/', clip_fn]);
            if size(clips(num_clips).data, 2) == 2
                clips(num_clips).data = (clips(num_clips).data(:, 1) + clips(num_clips).data(:, 2))/2;
            end
            norm_ratio = (abs(max(clips(num_clips).data)) + abs(min(clips(num_clips).data)))/2;
            clips(num_clips).data = clips(num_clips).data/norm_ratio;
            if fs ~= 8000
                disp(['Error: fs not equal to 8000.  fs = ', num2str(fs)]);
            end
        catch
            num_clips = num_clips - 1;
            lasterr;
            disp(['Error reading file  " ' clip_fn ' " ']);
        end
    end