% test classifiers on sound clips

function test_classifiers_clips(first_obj, last_obj, num_stages)

object_name(1).name = 'car_horn';
object_name(2).name = 'close_door';
object_name(3).name = 'dog_bark';
object_name(4).name = 'door_bell';
object_name(5).name = 'explosion';
object_name(6).name = 'female_laugh';
object_name(7).name = 'gunshot';
object_name(8).name = 'laser_gun';
object_name(9).name = 'light_saber';
object_name(10).name = 'male_laugh';
object_name(11).name = 'meow';
object_name(12).name = 'phone';
object_name(13).name = 'scream';
object_name(14).name = 'swords';


for i = first_obj:last_obj
        
    clear classifiers;
    
    for s = 1:num_stages 
        load(['./data/online_training/' object_name(i).name '/global_classifier', num2str(s), '.mat']);
        if s == num_stages
            global_classifier.threshold = 0;
        end
        classifiers(s) = global_classifier;
    end
    error_dir = ['./tmp/' object_name(i).name];
    if exist(error_dir) == 0
        mkdir('./tmp', object_name(i).name);
    end
    delete(['./tmp/' object_name(i).name '/*.wav']);    
    
    disp(['testing ' object_name(i).name]);
    
    data_dir = './data';    
    pos_clip_list = ['./data/online_training/' object_name(i).name '/positive_list.txt'];
    neg_clip_list = ['./data/online_training/' object_name(i).name '/negative_list.txt'];
    num_neg = 5000;
    num_synth = 15;        
    [error_rate, threshold, results] = test_clips(data_dir, pos_clip_list, neg_clip_list, num_synth, num_neg, classifiers, error_dir);
    classifiers(num_stages).threshold = threshold;
    global_classifier = classifiers(num_stages);
    save(['./data/online_training/' object_name(i).name '/global_classifier', num2str(num_stages), '.mat'], ...
          'global_classifier');
    
        
    disp('  ');
    
    if 1
        for s = 1:length(results.passed)
            if ~results.passed(s)
                results.confidences(s) = -1E10;
            end
        end
                
        [roc, true_pos, false_pos] = compute_roc(results.confidences, results.labels);
        figure(1), plot(false_pos, true_pos)
    end
    
end

end