function [confidence, passed] = test_single_clip(data, global_classifiers)
    
    features = extract_global_features_window(data, global_classifiers(1).fft_params);
    features = transpose(features);
    
    passed = 1;
    
    num_stages = length(global_classifiers);
    for stage = 1:num_stages

%         if stage > 1          
%             if stage == 2
%                 features = [features confidence];
%             else
%                 features(end) = confidence;
%             end
%         end       
        num_trees = length(global_classifiers(stage).wcs);

        confidence = 0;
        for t = 1:num_trees            
            [class_label, node_id] = treeval(global_classifiers(stage).wcs(t).tree, features);
            confidence = confidence + global_classifiers(stage).wcs(t).node_confidences(node_id);
        end                    
        
        if confidence < global_classifiers(stage).threshold
            passed = 0;
            break;
        end                    
        
    end