function boundaries = select_band_boundaries(data_dir, audio_file_list, min_freq, max_freq, num_bands, output_dir)
    
    fs = 8000;        
    
    clips = read_wav_files(data_dir, audio_file_list);
    
    num_clips = length(clips);
    
    total_power = 0;
    for i = 1:num_clips
        clip_length = length(clips(i).data);

        clips(i).fft_data = fft(clips(i).data);
        clips(i).num_seconds = clip_length / fs;
        clips(i).fft_data = ...
            abs(clips(i).fft_data(floor(min_freq*clips(i).num_seconds+1) : ...
                                  floor(max_freq*clips(i).num_seconds+1))).^2 ...
            / (clip_length/2);
        total_power = total_power + sum(clips(i).fft_data);
    end
    
    
    boundaries = zeros(num_bands+1, 1);
    step = 10;
    band_power = 0;
    old_band_power = 0;
    band_count = 1;
    
    boundaries(1) = min_freq;
    for f = 0:step:(max_freq-min_freq-step)        
        for i = 1:num_clips
            ns = clips(i).num_seconds;            
            band_power = band_power + sum(clips(i).fft_data(floor(f*ns+1):floor((f+step)*ns)));
        end
        if (band_power >= band_count*total_power/num_bands)            
            band_count = band_count + 1;
            boundaries(band_count) = min_freq + f;
        end
    end   
    boundaries(num_bands+1) = max_freq;
    
    fft_band_boundaries = boundaries;
    save([output_dir, '/fft_band_boundaries.mat'], 'fft_band_boundaries');